var tabla;

//Función que se ejecuta al inicio
function init(){
	mostrarform(false);
	listar();

	$("#formulario").on("submit",function(e)
	{
		guardaryeditar(e);	
	})
}

//Función limpiar
function limpiar()
{
	$("#idconfiguracion").val("");
	$("#razon_social").val("");
	$("#ruc").val("");
	$("#email").val("");
	$("#telefono").val("");
	$("#direccion").val("");
	$("#responsable").val("");
}

//Función mostrar formulario
function mostrarform(flag)
{
	limpiar();
	if (flag)
	{
		$("#listadoregistros").hide();
		$("#formularioregistros").show();
		$("#btnGuardar").prop("disabled",false);
		$("#btnagregar").hide();
	}
	else
	{
		$("#listadoregistros").show();
		$("#formularioregistros").hide();
		$("#btnagregar").show();
		$("#btnagregar").hide();
	}
}

//Función cancelarform
function cancelarform()
{
	limpiar();
	mostrarform(false);
}

//Función Listar
function listar()
{
	tabla=$('#tbllistado').dataTable(
	{
		"aProcessing": true,//Activamos el procesamiento del datatables
	    "aServerSide": true,//Paginación y filtrado realizados por el servidor
	    dom: 'Bfrtip',//Definimos los elementos del control de tabla
	    buttons: [		          
		            'copyHtml5',
		            'excelHtml5',
		            'csvHtml5',
		            'pdf'
		        ],
		"ajax":
				{
					url: '../ajax/configuracion.php?op=listar',
					type : "get",
					dataType : "json",						
					error: function(e){
						console.log(e.responseText);	
					}
				},
		"bDestroy": true,
		"iDisplayLength": 5,//Paginación
	    "order": [[ 0, "desc" ]]//Ordenar (columna,orden)
	}).DataTable();
}
//Función para guardar o editar

function guardaryeditar(e)
{
	e.preventDefault(); //No se activará la acción predeterminada del evento
	$("#btnGuardar").prop("disabled",true);
	var formData = new FormData($("#formulario")[0]);

	$.ajax({
		url: "../ajax/configuracion.php?op=guardaryeditar",
	    type: "POST",
	    data: formData,
	    contentType: false,
	    processData: false,

	    success: function(datos)
	    {                    
	          bootbox.alert(datos);	          
	          mostrarform(false);
	          tabla.ajax.reload();
	    }

	});
	limpiar();
}

function mostrar(idconfiguracion)
{
	$.post("../ajax/configuracion.php?op=mostrar",{idconfiguracion : idconfiguracion}, function(data, status)
	{
		data = JSON.parse(data);		
		mostrarform(true);

		$("#razon_social").val(data.razon_social);
		$("#ruc").val(data.ruc);
		$("#email").val(data.email);
		$("#telefono").val(data.telefono);
		$("#direccion").val(data.direccion);
		$("#responsable").val(data.responsable);
 		$("#idconfiguracion").val(data.idconfiguracion);

 	})
}

//Función para desactivar registros
function desactivar(idconfiguracion)
{
	bootbox.confirm("¿Está Seguro de desactivar el diagnostico?", function(result){
		if(result)
        {
        	$.post("../ajax/configuracion.php?op=desactivar", {idconfiguracion : idconfiguracion}, function(e){
        		bootbox.alert(e);
	            tabla.ajax.reload();
        	});	
        }
	})
}

//Función para activar registros
function activar(idconfiguracion)
{
	bootbox.confirm("¿Está Seguro de activar el diagnostico?", function(result){
		if(result)
        {
        	$.post("../ajax/configuracion.php?op=activar", {idconfiguracion : idconfiguracion}, function(e){
        		bootbox.alert(e);
	            tabla.ajax.reload();
        	});	
        }
	})
}


init();